#pragma once
#ifndef DF4_CRYPT_H
#define DF4_CRYPT_H

#include <array>

class df4_crypt
{
public:
    df4_crypt();
    ~df4_crypt();

    // Routinen fuer Verschluesselung der Paketdaten
protected:
    std::array<unsigned char, 256> m_sbox;
    std::array<unsigned char, 256> m_k;
    std::array<unsigned char, 32> m_key;
    bool m_binary_key;     // Handelt es sich um einen Binaerschluessel
    unsigned char m_size;  // Laenge des Binaerschluessels (max 32 Byte)

public:
    // Verschluesselungsroutinen
    void load_crypt_key();
    void set_key( unsigned char *key, bool binaryKey = false, unsigned char size = 0);
    void init();
    void crypt( unsigned char *data, std::size_t size );
    inline void set_key_byte( unsigned char pos, unsigned char val )
    {
        m_key[pos] = val;
    }
};

#endif
